package com.fs.his.service;

import com.fs.common.core.domain.R;
import com.fs.his.domain.FsIntegralGoods;
import com.fs.his.param.FsIntegralGoodsListUParam;
import com.fs.his.vo.FsIntegralGoodsChooseVO;
import com.fs.his.vo.FsIntegralGoodsListUVO;
import com.fs.his.vo.FsIntegralGoodsListVO;

import java.util.List;
import java.util.Map;

/**
 * 积分商品Service接口
 *
 * @author fs
 * @date 2023-11-02
 */
public interface IFsIntegralGoodsService
{
    /**
     * 查询积分商品
     *
     * @param goodsId 积分商品主键
     * @return 积分商品
     */
    public FsIntegralGoods selectFsIntegralGoodsByGoodsId(Long goodsId);

    /**
     * 查询积分商品列表
     *
     * @param fsIntegralGoods 积分商品
     * @return 积分商品集合
     */
    public List<FsIntegralGoods> selectFsIntegralGoodsList(FsIntegralGoods fsIntegralGoods);

    /**
     * 新增积分商品
     *
     * @param fsIntegralGoods 积分商品
     * @return 结果
     */
    public int insertFsIntegralGoods(FsIntegralGoods fsIntegralGoods);

    /**
     * 修改积分商品
     *
     * @param fsIntegralGoods 积分商品
     * @return 结果
     */
    public int updateFsIntegralGoods(FsIntegralGoods fsIntegralGoods);

    /**
     * 批量删除积分商品
     *
     * @param goodsIds 需要删除的积分商品主键集合
     * @return 结果
     */
    public int deleteFsIntegralGoodsByGoodsIds(Long[] goodsIds);

    /**
     * 删除积分商品信息
     *
     * @param goodsId 积分商品主键
     * @return 结果
     */
    public int deleteFsIntegralGoodsByGoodsId(Long goodsId);

    List<FsIntegralGoodsListVO> selectFsIntegralGoodsListVO(FsIntegralGoods fsIntegralGoods);

    List<FsIntegralGoodsListUVO> selectFsIntegralGoodsListUVO(FsIntegralGoodsListUParam param);

    String importIntegralGoodsService(List<FsIntegralGoods> list);

    R getCourseIntegralGoods(Long userId);

    /**
     * 获取选择积分商品列表
     */
    List<FsIntegralGoodsChooseVO> getChooseIntegralGoodsListByMap(Map<String, Object> params);
}
